--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use STD.env.all;

entity FULLADD_TB is
end FULLADD_TB;

architecture SIM of FULLADD_TB is
  -- 
component FULLADD
  port (
    A, B, CIN : in  std_logic;
    Q, COUT   : out std_logic 
  );
end component;

  -- 
  signal A, B, CIN : std_logic;
  signal q, cout   : std_logic;
  
begin
  -- 
  U0 : FULLADD port map (
    A   => A, 
    B   => B, 
    CIN => CIN, 
    Q   => q, 
    COUT=> cout
  );

  process begin  -- 
    A <= '0'; B <= '0'; CIN <= '0'; wait for 1000 ns;
    A <= '0'; B <= '0'; CIN <= '1'; wait for 1000 ns;
    A <= '0'; B <= '1'; CIN <= '0'; wait for 1000 ns;
    A <= '0'; B <= '1'; CIN <= '1'; wait for 1000 ns;
    A <= '1'; B <= '0'; CIN <= '0'; wait for 1000 ns;
    A <= '1'; B <= '0'; CIN <= '1'; wait for 1000 ns;
    A <= '1'; B <= '1'; CIN <= '0'; wait for 1000 ns;
    A <= '1'; B <= '1'; CIN <= '1'; wait for 1000 ns;
    std.env.finish(1);
  end process;

end SIM;

--
configuration CFG_FULLADD_TB of FULLADD_TB is
  for SIM
  end for;
end CFG_FULLADD_TB;
