-- 
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity GIKETSU is
  port (
    A, B, C    : in  std_logic;
    MAJO, UNAN : out std_logic 
  );
end GIKETSU;

architecture RTL of GIKETSU is

signal ABC : std_logic_vector(2 downto 0);

begin

  ABC <= (A & B & C);
  
  process ( ABC ) begin
    case ( ABC ) is
      when "000" =>  MAJO <= '0'; UNAN <= '1';
      when "001" =>  MAJO <= '0'; UNAN <= '0';
      when "010" =>  MAJO <= '0'; UNAN <= '0';
      when "011" =>  MAJO <= '1'; UNAN <= '0';
      when "100" =>  MAJO <= '0'; UNAN <= '0';
      when "101" =>  MAJO <= '1'; UNAN <= '0';
      when "110" =>  MAJO <= '1'; UNAN <= '0';
      when "111" =>  MAJO <= '1'; UNAN <= '1';
      when others => MAJO <= 'X'; UNAN <= 'X';
    end case;
  end process;

end RTL;
