--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use STD.env.all;

entity GIKETSU_TB is
end GIKETSU_TB;

architecture SIM of GIKETSU_TB is
  -- 
component GIKETSU
  port (
    A, B, C    : in  std_logic;
    MAJO, UNAN : out std_logic 
  );
end component;

  -- 
  signal A, B, C    : std_logic;
  signal MAJO, UNAN : std_logic;
  constant STEP     : time := 1000 ns;

begin
  -- 
  U0 : GIKETSU port map (
    A    => A,
    B    => B,
    C    => C,
    MAJO => MAJO,
    UNAN => UNAN
  );

  process begin  -- 
    A <= '0'; B <= '0'; C <= '0'; wait for STEP;
    A <= '0'; B <= '0'; C <= '1'; wait for STEP;
    A <= '0'; B <= '1'; C <= '0'; wait for STEP;
    A <= '0'; B <= '1'; C <= '1'; wait for STEP;
    A <= '1'; B <= '0'; C <= '0'; wait for STEP;
    A <= '1'; B <= '0'; C <= '1'; wait for STEP;
    A <= '1'; B <= '1'; C <= '0'; wait for STEP;
    A <= '1'; B <= '1'; C <= '1'; wait for STEP;
    std.env.finish(1);
  end process;

end SIM;

--
configuration CFG_GIKETSU_TB of GIKETSU_TB is
  for SIM
  end for;
end CFG_GIKETSU_TB;
