--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity UPDOWN_CNT is
  port (
    CLK, RST_X, UP : in  std_logic;
    Q              : out std_logic_vector(3 downto 0) 
  );
end UPDOWN_CNT;

architecture RTL of UPDOWN_CNT is

signal Q_REF : std_logic_vector(3 downto 0);

begin

Q <= Q_REF;

process (CLK, RST_X) begin
  if (RST_X = '0') then
    Q_REF <= "0000";
  elsif (CLK'event and CLK = '1') then
    if (UP = '1') then
      Q_REF <= Q_REF + 1;
    else
      Q_REF <= Q_REF - 1;
    end if;
  end if;
end process;

end RTL;
