--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use STD.env.all;

entity UPDOWN_CNT_TB is
end UPDOWN_CNT_TB;

architecture SIM of UPDOWN_CNT_TB is
-- 
component UPDOWN_CNT
  port (
    CLK, RST_X, UP : in  std_logic;
    Q              : out std_logic_vector(3 downto 0)
  );
end component;

-- 
signal   CLK, RST_X, UP : std_logic;
signal   Q              : std_logic_vector(3 downto 0);
constant STEP     : time := 1000 ns;


begin
-- 
  U0: UPDOWN_CNT port map (
        CLK=>CLK, RST_X=>RST_X, UP=>UP, Q=>Q );

  process begin
    CLK <= '0';  wait for STEP/2;
    CLK <= '1';  wait for STEP/2;
  end process;

  process begin
    RST_X <= '1'; UP <= '1'; wait for STEP;
    RST_X <= '0';            wait for STEP;
    RST_X <= '1';            wait for STEP*20;
                  UP <= '0'; wait for STEP*8;
    RST_X <= '0';            wait for STEP;
    RST_X <= '1';            wait for STEP;
                             wait for STEP*8;
    std.env.finish(1);
  end process;

end SIM;

--
configuration CFG_UPDOWN_CNT_TB of UPDOWN_CNT_TB is
  for SIM
  end for;
end CFG_UPDOWN_CNT_TB;
