--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity KEYENC is
  port (
    KEY  : in  std_logic_vector(9 downto 0);
    KOUT : out std_logic_vector(3 downto 0) 
  );
end KEYENC;

architecture RTL of KEYENC is

begin

process (KEY) begin
  case (KEY) is
    when B"00_0000_0001" =>  KOUT <= X"0";
    when B"00_0000_0010" =>  KOUT <= X"1";
    when B"00_0000_0100" =>  KOUT <= X"2";
    when B"00_0000_1000" =>  KOUT <= X"3";
    when B"00_0001_0000" =>  KOUT <= X"4";
    when B"00_0010_0000" =>  KOUT <= X"5";
    when B"00_0100_0000" =>  KOUT <= X"6";
    when B"00_1000_0000" =>  KOUT <= X"7";
    when B"01_0000_0000" =>  KOUT <= X"8";
    when B"10_0000_0000" =>  KOUT <= X"9";
    when B"00_0000_0000" =>  KOUT <= X"f";
    when others          =>  KOUT <= "XXXX";    --
  end case;
end process;

end RTL;
