--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use STD.env.all;

entity KEYENC_TB is
end KEYENC_TB;

architecture SIM of KEYENC_TB is
  -- 
component KEYENC
  port (
    KEY  : in  std_logic_vector(9 downto 0);
    KOUT : out std_logic_vector(3 downto 0)
  );
end component;

  -- 
  signal KEY  : std_logic_vector(9 downto 0);
  signal KOUT : std_logic_vector(3 downto 0);
  constant STEP : time := 1000 ns;

begin
  -- 
  U0 : KEYENC port map (
    KEY   => KEY,
    KOUT  => KOUT
  );

  process begin  -- 
    KEY <= B"00_0000_0001"; wait for STEP;  -- 0
    KEY <= B"00_0000_0000"; wait for STEP;  -- none
    KEY <= B"00_0000_0010"; wait for STEP;  -- 1
    KEY <= B"00_0000_0100"; wait for STEP;  -- 2
    KEY <= B"00_0000_1000"; wait for STEP;  -- 3
    KEY <= B"00_0001_0000"; wait for STEP;  -- 4
    KEY <= B"00_0010_0000"; wait for STEP;  -- 5
    KEY <= B"00_0100_0000"; wait for STEP;  -- 6
    KEY <= B"00_1000_0000"; wait for STEP;  -- 7
    KEY <= B"01_0000_0000"; wait for STEP;  -- 8
    KEY <= B"10_0000_0000"; wait for STEP;  -- 9

    KEY <= B"00_0000_1000"; wait for STEP;  -- 3
    KEY <= B"00_0001_1000"; wait for STEP;  -- 3,4
    KEY <= B"00_1000_0000"; wait for STEP;  -- 7
    KEY <= B"11_1000_0000"; wait for STEP;  -- 7,8,9
    KEY <= B"10_0000_0000"; wait for STEP;  -- 9
    std.env.finish(1);
  end process;

end SIM;

--
configuration CFG_KEYENC_TB of KEYENC_TB is
  for SIM
  end for;
end CFG_KEYENC_TB;
