--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity KEYDISP is
  port (
    KEY  : in  std_logic_vector(9 downto 0);
    A, B, C, D, E, F, G : out std_logic 
  );
end KEYDISP;

architecture RTL of KEYDISP is

component KEYENC
  port (
    KEY  : in  std_logic_vector(9 downto 0);
    KOUT : out std_logic_vector(3 downto 0) 
  );
end component;

component LED7DEC
  port (
    KIN : in  std_logic_vector(3 downto 0);
    LED : out std_logic_vector(6 downto 0) 
  );
end component;

signal kdecode  : std_logic_vector(3 downto 0);
signal abcdefg  : std_logic_vector(6 downto 0);

begin

  U_KEYENC : KEYENC port map (
    KEY  => KEY,
    KOUT => kdecode
  );

  U_LED7DEC : LED7DEC port map (
    KIN  => kdecode,
    LED  => abcdefg
  );
  
  A <= abcdefg(6);
  B <= abcdefg(5);
  C <= abcdefg(4);
  D <= abcdefg(3);
  E <= abcdefg(2);
  F <= abcdefg(1);
  G <= abcdefg(0);


end RTL;
