--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use STD.env.all;

entity CNT12_TB is
end CNT12_TB;

architecture SIM of CNT12_TB is
-- 
component CNT12
  port (
    CLK, RST_X, EN : in  std_logic;
    Q              : out std_logic_vector(3 downto 0) 
  );
end component;

-- 
signal   CLK, RST_X, EN : std_logic;
signal   Q              : std_logic_vector(3 downto 0);
constant STEP     : time := 1000 ns;


begin
-- 
  U0: CNT12 port map (
        CLK=>CLK, RST_X=>RST_X, EN=>EN, Q=>Q );

  process begin
    CLK <= '0';  wait for STEP/2;
    CLK <= '1';  wait for STEP/2;
  end process;

  process begin
    RST_X <= '1'; EN <= '0'; wait for STEP;
    RST_X <= '0';            wait for STEP;
    RST_X <= '1';            wait for STEP;
                  EN <= '1'; wait for STEP*11;
                  EN <= '0'; wait for STEP*3;
                  EN <= '1'; wait for STEP*15;
    std.env.finish(1);
  end process;

end SIM;

--
configuration CFG_CNT12_TB of CNT12_TB is
  for SIM
  end for;
end CFG_CNT12_TB;
