library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity SAIKORO is
  port (
      CLK, RST_X, EN  : in  std_logic;
      LAMP    : out std_logic_vector(6 downto 0) 
  );
end SAIKORO;

architecture RTL of SAIKORO is
  signal Q_REF : std_logic_vector(2 downto 0);

begin

  process (CLK, RST_X) begin
    if (RST_X = '0') then
      Q_REF<= "001";
    elsif (CLK'event and CLK = '1') then
      if (EN = '1') then
        if (Q_REF = "110") then
          Q_REF <= "001";
        else
          Q_REF <= Q_REF + 1;
        end if;
      end if;
    end if;
  end process;

  process (Q_REF) begin
    case Q_REF is
      when "001"  => LAMP <= "0001000";
      when "010"  => LAMP <= "1000001";
      when "011"  => LAMP <= "0011100";
      when "100"  => LAMP <= "1010101";
      when "101"  => LAMP <= "1011101";
      when "110"  => LAMP <= "1110111";
      when others => LAMP <= "XXXXXXX";
    end case;
  end process;

end RTL;
