--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use STD.env.all;

entity SAIKORO_TB is
end SAIKORO_TB;

architecture SIM of SAIKORO_TB is
-- 
component SAIKORO
  port (
    CLK, RST_X, EN : in  std_logic;
    LAMP    : out std_logic_vector(6 downto 0)  
  );
end component;

-- 
signal   CLK, RST_X, EN : std_logic;
signal   LAMP           : std_logic_vector(6 downto 0);
constant STEP     : time := 100 ns;


begin
-- 
  U0: SAIKORO port map (
        CLK=>CLK, RST_X=>RST_X, EN=>EN, LAMP=>LAMP );

  process begin
    CLK <= '0';  wait for STEP/2;
    CLK <= '1';  wait for STEP/2;
  end process;

  process begin
    RST_X <= '1'; EN <= '0'; wait for STEP;
    RST_X <= '0';            wait for STEP;
    RST_X <= '1';            wait for STEP;
                  EN <= '1'; wait for STEP*15;
                  EN <= '0'; wait for STEP*3;
                  EN <= '1'; wait for STEP*5;
    std.env.finish(1);
  end process;

end SIM;

--
configuration CFG_SAIKORO_TB of SAIKORO_TB is
  for SIM
  end for;
end CFG_SAIKORO_TB;
