library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity DECDIV is
  port (
    CLK, RST_X, LD : in  std_logic;
    DIN            : in  std_logic_vector(7 downto 0);
    DOUT           : out std_logic_vector(7 downto 0) 
  );
end DECDIV;

architecture RTL of DECDIV is
  signal DOUT_REF  : std_logic_vector(7 downto 0);
  signal DOUT_NEXT : std_logic_vector(7 downto 0);

begin
  DOUT <= DOUT_REF;
  
  process (LD, DIN, DOUT_REF) begin
    if (LD = '1') then
      DOUT_NEXT <= DIN;
    elsif (DOUT_REF(0) = '1') then
      DOUT_NEXT <= DOUT_REF - 1;
    else
      DOUT_NEXT <= ('0' & DOUT_REF(7 downto 1));
    end if;
  end process;

  process (CLK, RST_X) begin
    if (RST_X = '0') then
      DOUT_REF <= X"00";
    elsif (CLK'event and CLK = '1') then
      DOUT_REF <= DOUT_NEXT;
    end if;
  end process;

end RTL;
