--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use STD.env.all;

entity DECDIV_TB is
end DECDIV_TB;

architecture SIM of DECDIV_TB is
-- 
component DECDIV
  port (
    CLK, RST_X, LD : in  std_logic;
    DIN            : in  std_logic_vector(7 downto 0);
    DOUT           : out std_logic_vector(7 downto 0) 
  );
end component;

signal CLK, RST_X, LD : std_logic;
signal DIN            : std_logic_vector(7 downto 0);
signal DOUT           : std_logic_vector(7 downto 0);

constant STEP         : time := 1000 ns;


begin
-- 
  U0: DECDIV port map (
        CLK=>CLK, RST_X=>RST_X, LD=>LD, DIN=>DIN, DOUT=>DOUT );

  process begin
    CLK <= '0';  wait for STEP/2;
    CLK <= '1';  wait for STEP/2;
  end process;

  process begin
    DIN <= X"FF";
    RST_X <= '1'; LD <= '0'; wait for STEP;
    RST_X <= '0';            wait for STEP;
    RST_X <= '1'; LD <= '1'; wait for STEP*2;
                  LD <= '0'; wait for STEP*18;
    DIN <= X"E0";            wait for STEP*2;
                  LD <= '1'; wait for STEP*1;
                  LD <= '0'; wait for STEP*18;
    std.env.finish(1);
  end process;

end SIM;

--
configuration CFG_DECDIV_TB of DECDIV_TB is
  for SIM
  end for;
end CFG_DECDIV_TB;
