--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use STD.env.all;

entity COUNTER_TB is
end COUNTER_TB;

architecture SIM of COUNTER_TB is
-- 
component COUNTER
  port(CLK, RST_X:  in std_logic;
               Q : out std_logic_vector(3 downto 0));
end component;

-- 
signal   CLK, RSTX: std_logic;
signal   QOUT     : std_logic_vector(3 downto 0);
constant STEP     : time := 1000 ns;


begin
-- 
  U0: COUNTER port map (
        CLK=>CLK, RST_X=>RSTX, Q=>QOUT );

  process begin
    CLK <= '0';  wait for STEP/2;
    CLK <= '1';  wait for STEP/2;
  end process;

  process begin
    RSTX <= '1';  wait for STEP;
    RSTX <= '0';  wait for STEP;
    RSTX <= '1';  wait for STEP*20;
    std.env.finish(1);
  end process;

end SIM;

--
configuration CFG_COUNTER_TB of COUNTER_TB is
  for SIM
  end for;
end CFG_COUNTER_TB;
